/'****************************************************************************
The MIT License

Copyright (c) 2011, Richard D. Clark

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

http://www.opensource.org/licenses/mit-license.php
*****************************************************************************'/

Namespace cproductions
	
#Include "cprod.bi"

#Define numstars 1000
#define maxdist 1000
#define stlow -1500
#define sthigh 1500

Type stars
    x As Double
    y As Double
    z As Double
    zv As Double
End Type

Type scrloc
    x As Integer
    y As Integer
    z As Integer
End Type

Const cx = sw / 2
Const cy = sh / 2
Const cprodxoffset = cx - (cprodw / 2)
Const cprodyoffset = cy - (cprodh / 2)
Const white = RGB(255, 255, 255)

Dim Shared star(0 To numstars) As stars
Dim Shared sloc(0 To numstars) As scrloc


Sub DoStar(idx As Integer)
    star(idx).x = cards.Rand(stlow, sthigh)
    star(idx).y = cards.Rand(stlow, sthigh)
    star(idx).z = cards.Rand(100, maxdist)
    star(idx).zv = cards.Rand(1, 10)
End Sub

Sub DrawLogos (cpalpha As Integer)
	Dim As Integer x, y
	Dim As UInteger newpixel, spixel, lpixel
	
	For x = 0 To cprodw - 1
		For y = 0 To cprodh - 1
			lpixel = cprod(x + y * cprodw)
			If lpixel <> &hFF000000 Then
				spixel = Point(x, y)
				newpixel = DoAlphaBlend(cpalpha, lpixel, spixel)
				PSet(cprodxoffset + x, cprodyoffset + y), newpixel
			EndIf
		Next	
	Next

End Sub

Sub DoCPIntro()
	Dim As Integer i, cpalpha, ret = 0
	Dim As String ch
	Dim As Single tc, tcp
	
	For i = 0 To numstars
	    DoStar(i)
	Next
	tc = Timer
	tcp = Timer
	cpalpha = 1
	Do
		ch = InKey
		 ScreenLock
	    Cls
	    For i = 0 To numstars
	       star(i).z -= star(i).zv
	        sloc(i).x = star(i).x / star(i).z * 200 + cx
	        sloc(i).y = star(i).y / star(i).z * 200 + cy
	        sloc(i).z = star(i).z
		     If sloc(i).x < 0 Or sloc(i).x > sw - 1 Or sloc(i).y < 0 Or sloc(i).y > sh - 1 Or star(i).z < 0 Then
	            DoStar(i)
		     End If
	        PSet (sloc(i).x, sloc(i).y), fbwhite
	    Next
	    If Timer > (tcp + .1) Then
	    	DrawLogos cpalpha
	    	cpalpha += 1
	    	If cpalpha > 255 Then cpalpha = 255
	    End If
	    ScreenUnlock
	    Sleep 1
	Loop Until (ch <> "" ) Or Timer > (tc + 5)
End Sub

End Namespace
